/*
 *  $Id: dev_dos.cc,v 1.1.1.1 1997/10/25 23:11:07 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#include <iostream.h>
#include <iomanip.h>

#ifdef MSDOS
#include <dir.h>
#include <bios.h>
#endif /* MSDOS */

#include "vc1541/dev_dos.h"

FileSystemDevDOS::FileSystemDevDOS(void) : FileSystem(NULL, "DEV")
{
#ifdef LINUX
   _dir->add("/", 0, "DEV");
#endif /* LINUX */
#ifdef MSDOS
	int a, c;
        char buf[3];

        c = 0;
       	cout << "checking devices..." << flush;
        for (a = 0;a < 26;a++) {
        	if (checkDevice(a)) {
                	c++;
                	sprintf(buf, "%c:", 'A' + a);
			_dir->add(buf, 0, "DEV");
                        cout << ' ' << (char)('A' + a) << flush;
                }
        }

        if (c == 0) {
        	cout << " hmm, no device found!\n";
                cout << "Where am I started from?\n";
                exit(1);
       	}
       	cout << " ok, found " << c << " device"
             << ((c == 1) ? "" : "s") << ".\n";
#endif /* MSDOS */
}

FileSystemDevDOS::~FileSystemDevDOS(void)
{
}

#ifdef MSDOS
int FileSystemDevDOS::checkDevice(int device)
{
	int a, curdisk;

	curdisk = getdisk();
	setdisk(device);
	a = (device == getdisk());
	setdisk(curdisk);
	if (!a) return 0;

	/*
	 *  special handling for a: and b:
	 */
	if ((device == 0) || (device == 1)) {
        	a = biosequip(); /* BIOS: get configuration word */
		if ((a & 1) == 0) return 0;
		a = (a >> 6) & 3;
		if (device > a) return 0;
	}

	return 1;
}
#endif /* MSDOS */

