/*
 *  $Id: fs.cc,v 1.1.1.1 1997/10/25 23:11:07 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#include <string.h>

#include "vc1541/fs.h"

FileSystem::FileSystem(File *file, char *fstype)
{
	_file = file;
	_dir = new Directory;
	_cur_dirent = NULL;
	_fstype = new char[strlen(fstype) + 1];
	strcpy(_fstype, fstype);
}

FileSystem::~FileSystem(void)
{
	delete _dir;
	delete _fstype;
	delete _file;
}

Directory * FileSystem::get_dir(void)
{
	return _dir;
}

char * FileSystem::get_path(void)
{
	if (_cur_dirent == NULL) return NULL;
        return _cur_dirent->name();
}

File * FileSystem::file(void)
{
	return _file;
}

char * FileSystem::fstype(void)
{
	return _fstype;
}

DirectoryEntry * FileSystem::chdir(DirectoryEntry *e)
{
	DirectoryEntry *_tmp = _cur_dirent;

	_cur_dirent = e;

	return _tmp;
}

File * FileSystem::open(char *path, DirectoryEntry *e)
{
	return new File(path, e->name());
}

