/*
 *  $Id: fs_dos.cc,v 1.1.1.1 1997/10/25 23:11:08 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#ifdef MSDOS

#include <ctype.h>
#include <dirent.h>
#include <sys/vfs.h>

#include "misc/debug.h"
#include "vc1541/fs_dos.h"

FileSystemDOS::FileSystemDOS(File *file) : FileSystem(file, "DOS Directory")
{
	DIR *d;
	struct stat st;
        struct statfs stfs;
	char *path;
	char *type, *buf;
	struct dirent *ent;
	int a, len, blocks;
	char p[1024];

	path = file->path();
	if ((d = opendir(path)) == NULL) return;
        if (statfs(path, &stfs) != 0) return;

	_dir->set_title(file->name(),
			(stfs.f_bfree * stfs.f_bsize) / 254);

	while ((ent = readdir(d)) != NULL) {
        	if (strcmp(ent->d_name, ".") == 0) continue;
                if (strcmp(ent->d_name, "..") == 0) continue;
		a = strlen(path);
		if (a > 0 && path[a - 1] == '\\') {
			sprintf(p, "%s%s", path, ent->d_name);
		} else {
			sprintf(p, "%s\\%s", path, ent->d_name);
		}
		if (stat(p, &st) == -1) {
			type = " ??? ";
		} else {
			if (st.st_mode & S_IFDIR) {
				type = " DIR ";
			} else {
				type = " PRG ";
			}
		}
		blocks = (st.st_size + 253) / 254;

		len = strlen(ent->d_name);
		buf = new char[len + 1];
		for (a = 0;a < len;a++) {
			buf[a] = toupper(ent->d_name[a]);
		}
		buf[a] = '\0';
		_dir->add(buf, blocks, type);
		delete buf;
	}
	closedir(d);
}

FileSystem * FileSystemDOS::check(File *file)
{
	if (file->is_directory()) {
		*debug << "FileSystemDOS::check(): ok... " << file->path() << "\n";
		return new FileSystemDOS(file);
	}
	*debug << "FileSystemDOS::check(): failed!\n";
	return NULL;
}

File * FileSystemDOS::open(char *path, DirectoryEntry *e)
{
	return new File(path, e->name());
}

#endif /* MSDOS */

