/*
 *  $Id: fs_tar.cc,v 1.1.1.1 1997/10/25 23:11:07 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "misc/util.h"
#include "misc/debug.h"
#include "vc1541/fs_tar.h"

void FileSystemTAR::parse(char *filename)
{
	File *f;
	char *p, buf[1024];

	f = new TmpFile(filename);
        if (!f->ok()) {
        	delete f;
                return;
        }

	while (1) {
		if (f->fgets(buf, 1024) == NULL) {
                        delete f;
			return;
                }
                if ((p = strchr(buf, 0x0d))) *p = '\0';
                if ((p = strchr(buf, 0x0a))) *p = '\0';
		_dir->add(buf, 0, " PRG ");
        }
}

FileSystemTAR::FileSystemTAR(File *file) :
 		FileSystemEXEC(file, "External Archiver (TAR)")
{
	char buf[1024];
        char tmp_name[L_tmpnam];

	tmpnam(tmp_name);

       	sprintf(buf,
#ifdef MSDOS
               	"gtar tf %s > %s",
#endif /* MSDOS */
#ifdef LINUX
               	"tar tf '%s' > %s",
#endif /* LINUX */
       		file->realpath(), tmp_name);

	util_system(buf);

	parse(tmp_name);
}

File * FileSystemTAR::open(char * /*path*/, DirectoryEntry *e)
{
	char buf[1024];
        char tmp_name[L_tmpnam];

	tmpnam(tmp_name);

#ifdef MSDOS
	return NULL; /* fixme: implement tar dearchiving for dos */
#endif /* MSDOS */

#ifdef LINUX
       	sprintf(buf, "tar xOf '%s' '%s' > '%s'",
               	_file->realpath(), e->name(), tmp_name);
#endif /* LINUX */

        util_system(buf);

        return new TmpFile(tmp_name);
}

FileSystem * FileSystemTAR::check(File *file)
{
        if (check_type_exec(file, 257, 5, "ustar")) {
		*debug << "FileSystemTAR::check(): ok... " << file->path() << "\n";
		return new FileSystemTAR(file);
        }
	*debug << "FileSystemTAR::check(): failed!\n";
        return NULL;
}

