/*
 *  $Id: fs_unix.cc,v 1.1.1.1 1997/10/25 23:11:07 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#ifdef LINUX

#include <ctype.h>
#include <dirent.h>

#include "misc/debug.h"
#include "vc1541/fs_unix.h"

FileSystemUNIX::FileSystemUNIX(File *file) : FileSystem(file, "UNIX Directory")
{
	DIR *d;
	struct stat st;
	char *path;
	char *type, *buf;
	struct dirent *ent;
	int a, len, blocks;
	char p[1024];

	path = file->path();
	if ((d = opendir(path)) == NULL) return;

	_dir->set_title(file->name(), 0);

	while ((ent = readdir(d)) != NULL) {
		a = strlen(path);
		if (a > 0 && path[a - 1] == '/') {
			sprintf(p, "%s%s", path, ent->d_name);
		} else {
			sprintf(p, "%s/%s", path, ent->d_name);
		}
		if (stat(p, &st) == -1) {
			type = " ??? ";
		} else {
			if (st.st_mode & S_IFDIR) {
				type = " DIR ";
			} else {
				type = " PRG ";
			}
		}
		blocks = (st.st_size + 253) / 254;

		len = strlen(ent->d_name);
		buf = new char[len + 1];
		strcpy(buf, ent->d_name);
		_dir->add(buf, blocks, type);

		delete buf;
	}
	closedir(d);
}



FileSystem * FileSystemUNIX::check(File *file)
{
	if (file->is_directory()) {
		*debug << "FileSystemUNIX::check(): ok... " << file->path() << "\n";
		return new FileSystemUNIX(file);
	}
	*debug << "FileSystemUNIX::check(): failed!\n";
	return NULL;
}

#endif /* LINUX */

