/*
 *  $Id: fs_zip.cc,v 1.1.1.1 1997/10/25 23:11:07 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "misc/util.h"
#include "misc/debug.h"
#include "vc1541/fs_zip.h"

void FileSystemZIP::parse(char *filename)
{
        File *f;
        int state;
        int blocks;
	char *p, buf[1024];

	f = new TmpFile(filename);
        if (!f->ok()) {
        	delete f;
                return;
        }

        state = 0;
	while (1) {
		if (f->fgets(buf, 1024) == NULL) {
                	delete f;
			return;
                }
                switch (state) {
                case 0:
                	if (buf[1] == '-') state = 1;
                        break;
		case 1:
                	if (buf[1] == '-') {
                                delete f;
                		return;
                        }
                        buf[7] = '\0';
                        if ((p = strchr(buf + 27, 0x0d))) *p = '\0';
                        if ((p = strchr(buf + 27, 0x0a))) *p = '\0';
                        blocks = atol(buf);
                        if (blocks > 0) blocks = blocks / 254 + 1;
			_dir->add(buf + 27, blocks, " PRG ");
                }
        }
}

FileSystemZIP::FileSystemZIP(File *file) :
 		FileSystemEXEC(file, "External Archiver (ZIP)")
{
	char buf[1024];
        char tmp_name[L_tmpnam];

	tmpnam(tmp_name);

        sprintf(buf,
#ifdef MSDOS
		"unzip386 -l -U %s > %s",
#endif /* MSDOS */
#ifdef LINUX
		"unzip -l -U '%s' > '%s'",
#endif /* LINUX */
		file->realpath(), tmp_name);

        util_system(buf);
        parse(tmp_name);
}

File * FileSystemZIP::open(char * /*path*/, DirectoryEntry *e)
{
	char buf[1024];
        char tmp_name[L_tmpnam];

	tmpnam(tmp_name);

       	sprintf(buf,
#ifdef MSDOS
		"unzip386 -p %s %s > %s",
#endif /* MSDOS */
#ifdef LINUX
		"unzip -p '%s' '%s' > '%s'",
#endif /* LINUX */
		_file->realpath(), e->name(), tmp_name);

        util_system(buf);

        return new TmpFile(tmp_name);
}

FileSystem * FileSystemZIP::check(File *file)
{
        if (check_type_exec(file, 0, 2, "PK")) {
		*debug << "FileSystemZIP::check(): ok... " << file->path() << "\n";
		return new FileSystemZIP(file);
        }
	*debug << "FileSystemZIP::check(): failed!\n";
        return NULL;
}

