/*
 *  $Id: gui.h,v 1.1.1.1 1997/10/25 23:11:09 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#ifndef __gui_gui_h
#define __gui_gui_h

#include <stdio.h>
#include <string.h>

#define Uses_TScreen
#define Uses_TEventQueue
#define Uses_TDialog
#define Uses_TKeys
#define Uses_TDeskTop
#define Uses_TApplication
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_TMenuItem
#define Uses_TRect
#define Uses_TLabel
#define Uses_TButton
#define Uses_TWindow
#define Uses_TEvent
#define Uses_TStatusDef
#define Uses_TScrollBar
#define Uses_TStatusItem
#define Uses_TStatusLine
#define Uses_TScroller
#define Uses_TListViewer
#define Uses_TListBox
#define Uses_TTerminal
#define Uses_otstream
#define Uses_TStringCollection
#define Uses_TPalette
#include <tv.h>

#include "vc1541/dir.h"
#include "vc1541/device.h"

class GUI
{
protected:
	Device *_dev;
public:
	GUI(Device *dev) : _dev(dev) {}
	virtual bool poll(void) = 0;
};

class TChangeableText : public TView
{
public:
    TChangeableText(const TRect& bounds, const char *aText);
    ~TChangeableText();

    virtual void draw();
    virtual TPalette& getPalette() const;
    virtual void getText(char *);
    virtual void setText(char *);
protected:
    char *text;
};

class TDirList : public TListViewer
{
private:
	Device    *_dev;
	Directory *_dir;
public:
	TDirList::TDirList(const TRect &r, TScrollBar *vScrollBar, Device *dir);
	void getText(char *dest, ccIndex item, short maxLen);
	void handleEvent(TEvent &event);

	virtual char * getSelected(void);
	virtual void   update(int idx = 0);
};

class App : public GUI, public TApplication
{
private:
	TDirList        *_listbox;
	TChangeableText *_label;
        TChangeableText *_free;
	TWindow         *_termwin;
	TTerminal       *_terminal;

	static TMenuBar * initMenuBar(TRect r);
	static TStatusLine * App::initStatusLine(TRect r);
	void handleEvent(TEvent &event);
protected:
	void myNewWindow(void);
public:
	App(Device *dev);
	virtual bool poll(void);
};

#endif /* __gui_gui_h */

