/*
 *  $Id: device.h,v 1.1.1.1 1997/10/25 23:11:09 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#ifndef __vc1541_device_h
#define __vc1541_device_h

#include "misc/vector.h"
#include "vc1541/dir.h"
#include "vc1541/file.h"

class FileSystem;
class FSFactory;

class Device
{
private:
	int                   _id;
	FileSystem           *_root;
	FSFactory            *_fs_factory;
	Vector<FileSystem *>  _fs;
public:
	Device(FSFactory *fs_factory, int id);
        Directory * readdir(void);
	File *open(char *name);
	int id(void);
        char * path(void);
        int chdir(char *path);
	char * fstype(void);
};

typedef int device_t;

#endif /* __vc1541_device_h */
