/*
 *  $Id: file.h,v 1.1.1.1 1997/10/25 23:11:09 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#ifndef __vc1541_file_h
#define __vc1541_file_h

#include <stdio.h>
#include <string.h>

#undef getc

typedef enum {
        File_RO, File_WR, File_RDWR
} file_mode_t;

class File
{
protected:
          FILE *_f;
          char *_mode;
          char *_name;
          char *_path;
          char *_realpath;
          char *_buf;
          long _size;
          bool _ok, _dir, _reg;

          void check_gzip(void);
public:
	File(char *path, char *name = NULL, file_mode_t mode = File_RO);
        virtual ~File(void);

	virtual void   rewind(void);
	virtual bool   seek(long offset);
	virtual long   read(void *buf, long len);
        virtual long   write(void *buf, long len);
	virtual int    getc(void);
        virtual char * fgets(void *buf, long maxlen);

	virtual char * dir(void);
        virtual char * name(void);
	virtual char * path(void);
	virtual char * realpath(void);
	virtual long size(void);
        virtual bool ok(void);
        virtual bool is_regular(void);
        virtual bool is_directory(void);
};

class TmpFile : public File
{
public:
	TmpFile(char *path, char *name = NULL, file_mode_t mode = File_RO);
        virtual ~TmpFile(void);
};

#endif /* __vc1541_file_h */

