/*
 *  $Id: fs.h,v 1.1.1.1 1997/10/25 23:11:08 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#ifndef __vc1541_fs_h
#define __vc1541_fs_h

#include "vc1541/dir.h"
#include "vc1541/file.h"

class FileSystem
{
private:
	char *_fstype;

protected:
	File *_file;
	Directory *_dir;
	DirectoryEntry *_cur_dirent;

public:
	FileSystem(File *file, char *fstype);

	virtual ~FileSystem(void);
	virtual DirectoryEntry * chdir(DirectoryEntry *e);
	virtual File * open(char *path, DirectoryEntry *e);

	virtual Directory * get_dir(void);
	virtual char * get_path(void);
	virtual File * file(void);
	virtual char * fstype(void);
};

#endif /* __vc1541_fs_h */

