/*
 *  $Id: fs_fact.h,v 1.1.1.1 1997/10/25 23:11:09 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#ifndef __vc1541_fs_fact_h
#define __vc1541_fs_fact_h

#include "vector.h"

#include "vc1541/fs.h"
#include "vc1541/dir.h"
#include "vc1541/file.h"
#include "vc1541/device.h"

typedef FileSystem * (*check_func)(File *);

class FSFactory
{
private:
        Vector<check_func> _check;
public:
	FSFactory(void);
	void register_fs(check_func f);
	FileSystem * get_fs(Device *dev, FileSystem *fs, DirectoryEntry *e);
};

#endif /* __vc1541_fs_fact_h */
