/*
 *  $Id: fs_lnx.h,v 1.1.1.1 1997/10/25 23:11:09 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#ifndef __vc1541_fs_lnx_h
#define __vc1541_fs_lnx_h

#include "vc1541/fs.h"
#include "vc1541/file.h"

class FileSystemLNX : public FileSystem
{
private:
	const int BLOCK_LEN = 254;
	const int CHECK_LEN = 254;
	int lnx_get_header(char *buf, word_t *dirlen, word_t *direntries);
	char * lnx_getstr(word_t *a, char *dirmem, word_t dirlen);
	static bool check_type_lnx(File *file);
public:
	FileSystemLNX(File *file);
	~FileSystemLNX(void);
	File * open(char *path, DirectoryEntry *e);

	static FileSystem * check(File *file);
};

#endif /* __vc1541_fs_lnx_h */

