/*
 *  $Id: fs_t64.h,v 1.1.1.1 1997/10/25 23:11:09 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#ifndef __vc1541_fs_t64_h
#define __vc1541_fs_t64_h

#include "vc1541/fs.h"
#include "vc1541/file.h"

class FileSystemT64 : public FileSystem
{
private:
	const int CHECK_LEN = 20;
	static bool check_type_t64(File *file);
public:
	FileSystemT64(File *file);
	~FileSystemT64(void);

	virtual File * open(char *path, DirectoryEntry *e);

	static FileSystem * check(File *file);
};

struct t64_tape {
	char  desc[32];
	char  minor;
	char  major;
	short entries;
	short used;
	short _unused;
	char  user_desc[24];
};

struct t64_file {
	unsigned char  entry_type;
	unsigned char  file_type;
	unsigned short start;
	unsigned short end;
	short          _unused1;
	unsigned long  offset;
	long           _unused2;
	char           name[16];
};

typedef struct t64_tape t64_tape_t;
typedef struct t64_file t64_file_t;

#endif /* __vc1541_fs_t64_h */
