/*
 *  $Id: protocol.h,v 1.1.1.1 1997/10/25 23:11:09 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#ifndef __io_protocol_h
#define __io_protocol_h

#include "vc1541/io.h"
#ifndef __KERNEL__
#include "gui/gui.h"
#endif
#include "vc1541/device.h"

class Protocol
{
private:
	void   *_deferred_delete;
	IO     *_io;
#ifndef __KERNEL__
	GUI    *_gui;
	Device *_dev;
#endif
protected:
	int  getIEC(byte_t *ret);
	int  putIEC(byte_t b, int eoi = 0);
	void sendFile(File *file);
	void sendDir(Directory *dir);
	void sendDirLine(word_t *addr, DirectoryEntry *de);
	void handleATN(void);
	void handleTALK(Device *dev, int sec_addr, char *s);
	void handleLISTEN(Device *dev, int sec_addr, char *s);
	void handleCLOSE(void);
public:
	Protocol(IO *io
#ifndef __KERNEL__
		, GUI *gui, Device *dev
#endif
	);
	void execute(void);
};

#endif /* __io_protocol_h */

