/*
 *  $Id: main.cc,v 1.1.1.1 1997/10/25 23:11:07 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#include <stdio.h>

#include "gui/gui.h"
#ifdef MSDOS
#include "vc1541/io_dos.h"
#endif
#ifdef LINUX
#include "vc1541/io_linux.h"
#endif
#include "vc1541/protocol.h"
#include "vc1541/device.h"
#include "vc1541/fs_fact.h"

int main(void)
{
	FSFactory fs_factory;

#ifdef MSDOS
	IO       *io   = new IO_DOS(0);
#endif
#ifdef LINUX
	IO       *io   = new IO_Linux(0x378);
#endif

	Device   *dev  = new Device(&fs_factory, 8);

	GUI      *gui  = new App(dev);

	Protocol *prot = new Protocol(io, gui, dev);

#ifdef MSDOS
	prot->execute();
#endif /* MSDOS */
#ifdef LINUX
	((App *)gui)->run();
#endif /* LINUX */

	return 0;
}
