/*
 *  $Id: util.cc,v 1.1.1.1 1997/10/25 23:11:09 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of VC1541, the Commodore Floppy 1541 Emulator.
 */

#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>

#include "misc/util.h"
#include "misc/debug.h"

int util_system(const char *cmd, bool close_stdin)
{
	int a, fd, stdin_fd, stderr_fd;

	*debug << "util_system(): " << cmd << "\n";

	fd = open("/dev/null", O_RDWR);

        stderr_fd = dup(2); 		/* save stderr */
        close(2);        		/* close stderr */
        dup2(fd, 2);			/* new stderr */

        if (close_stdin) {
	        stdin_fd  = dup(0);	/* save stdin */
	        close(0);		/* close stdin */
	        dup2(fd, 0);		/* new stdin */
        }

        a = system(cmd);		/* run command */
        dup2(stderr_fd, 2);		/* restore stderr */
        close(stderr_fd);

        if (close_stdin) {
	        dup2(stdin_fd, 0);	/* restore stdin */
	        close(stdin_fd);	/* close temporary files */
        }

        close(fd);

        return a;
}

int util_glob(const char *f1, const char *f2, const bool ignorecase)
{
	while (1) {
		if (*f1 == '\0' && *f2 == '\0') return 1;
		if (*f1 == '\0') return 0;
		if (*f2 == '\0') {
			if (*f1 == '*') return 1;
			return 0;
		}
		if (ignorecase) {
			if (toupper(*f1) == toupper(*f2)) {
				f1++;
				f2++;
				continue;
			}
		} else {
			if (*f1 == *f2) {
				f1++;
				f2++;
				continue;
			}
		}
		if (*f1 == '*') return 1;
		return 0;
	}
}
